Deprecating MD5 and SHA-1 Signature Hashes in TLS 1.2 and DTLS 1.2
RFC 9155
Loganaden Velvindron
cyberstorm.mu
Rose Hill
Mauritius
+230 59762817
logan@cyberstorm.mu
Kathleen Moriarty
Center for Internet Security
East Greenbush
NY
United States of America
Kathleen.Moriarty.ietf@gmail.com
Alessandro Ghedini
Cloudflare Inc.
alessandro@cloudflare.com
December 2021
Security
TLS
tls
The MD5 and SHA-1 hashing algorithms are increasingly vulnerable to attack, and this document deprecates their use in TLS 1.2 and DTLS 1.2 digital signatures. However, this document does not deprecate SHA-1 with Hashed Message Authentication Code (HMAC), as used in record protection. This document updates RFC 5246.
Introduction
The usage of MD5 and SHA-1 for signature hashing in (D)TLS 1.2 is specified in [RFC5246]. MD5 and SHA-1 have been proven to be insecure, subject to collision attacks [Wang]. In 2011, [RFC6151] detailed the security considerations, including collision attacks for MD5. NIST formally deprecated use of SHA-1 in 2011 [NISTSP800-131A-R2] and disallowed its use for digital signatures at the end of 2013, based on both the attack described in [Wang] and the potential for brute-force attack. In 2016, researchers from the National Institute for Research in Digital Science and Technology (INRIA) identified a new class of transcript collision attacks on TLS (and other protocols) that relies on efficient collision-finding algorithms on the underlying hash constructions [Transcript-Collision]. Further, in 2017, researchers from Google and Centrum Wiskunde & Informatica (CWI) Amsterdam [SHA-1-Collision] proved SHA-1 collision attacks were practical. This document updates [RFC5246] in such a way that MD5 and SHA-1 MUST NOT be used for digital signatures. However, this document does not deprecate SHA-1 with HMAC, as used in record protection. Note that the CA/Browser Forum (CABF) has also deprecated use of SHA-1 for use in certificate signatures [CABF].
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Signature Algorithms
Clients MUST include the signature_algorithms extension. Clients MUST NOT include MD5 and SHA-1 in this extension.
Certificate Request
Servers SHOULD NOT include MD5 and SHA-1 in CertificateRequest messages.
Server Key Exchange
Servers MUST NOT include MD5 and SHA-1 in ServerKeyExchange messages. If the client receives a ServerKeyExchange message indicating MD5 or SHA-1, then it MUST abort the connection with an illegal_parameter alert.
Certificate Verify
Clients MUST NOT include MD5 and SHA-1 in CertificateVerify messages. If a server receives a CertificateVerify message with MD5 or SHA-1, it MUST abort the connection with an illegal_parameter alert.
IANA Considerations
IANA has updated the "TLS SignatureScheme" registry by changing the recommended status of SHA-1-based signature schemes to "N" (not recommended), as defined by [RFC8447]. The following entries have been updated; other entries in the registry remain the same.
Value | Description | Recommended | Reference
0x0201 | rsa_pkcs1_sha1 | N | [RFC8446] [RFC9155]
0x0203 | ecdsa_sha1 | N | [RFC8446] [RFC9155]
IANA has also updated the reference for the "TLS SignatureAlgorithm" and "TLS HashAlgorithm" registries to refer to this document in addition to RFCs 5246 and 8447.
Security Considerations
Concerns with (D)TLS 1.2 implementations falling back to SHA-1 is an issue. This document updates the TLS 1.2 specification [RFC5246] to deprecate support for MD5 and SHA-1 for digital signatures. However, this document does not deprecate SHA-1 with HMAC, as used in record protection.
References
Normative References
Informative References
[NISTSP800-131A-R2]

Transitioning the Use of Cryptographic Algorithms and Key Lengths
Elaine Barker
Allen Roginsky
March 2019
NIST Special Publication 800-131A, Revision 2
DOI 10.6028/NIST.SP.800-131Ar2
[CABF]

Ballot 118 -- SHA-1 Sunset (passed)
CA/Browser Forum
October 2014
[Transcript-Collision]

Transcript Collision Attacks: Breaking Authentication in TLS, IKE, and SSH
Karthikeyan Bhargavan
Gaetan Leurent
February 2016
DOI 10.14722/ndss.2016.23418
[SHA-1-Collision]

The First Collision for Full SHA-1
Marc Stevens
Elie Bursztein
Pierre Karpman
Ange Albertini
Yarik Markov
2017
[Wang]

Finding Collisions in the Full SHA-1
Xiaoyun Wang
Yiqun Lisa Yin
Hongbo Yu
2005
DOI 10.1007/11535218_2
[RFC5246]
[RFC6151]
[RFC2119]
[RFC8174]
[RFC8447]
[RFC8446]
Acknowledgements
The authors would like to thank Hubert Kario for his help in writing the initial draft version of this document. We are also grateful to Daniel Migault, Martin Thomson, Sean Turner, Christopher Wood, and David Cooper for their feedback.